.386
.model flat,stdcall
option casemap:none

include		windows.inc
include		gdi32.inc
includelib	gdi32.lib
include		user32.inc
includelib	user32.lib
include		kernel32.inc
includelib	kernel32.lib
include		RegEx.inc
includelib	RegEx.lib
include		macro.asm

.data?
	hInstance		dd ?

.data
	reg				db '<tr>[\s]*\r\n[\s]*<td [^>]*>[\s]*\r\n[\s]*([\w ]*)[\s]*\r\n[\s]*</td>[\s]*\r\n[\s]*</tr>',0

.const
	

.code

CopyString	proc uses esi edi ebx lpOutBuf:DWORD,lpSrc:DWORD,nOff:DWORD,nEnd:DWORD
		mov esi,lpSrc
		mov edi,lpOutBuf
		add esi,nOff
		mov ebx,nOff
		.while ebx<nEnd
			movsb
			inc ebx
		.endw
		mov al,0
		stosb
ret
CopyString	endp

RegMatch proc lpSource:DWORD,srcLen:DWORD,lpRegEx:DWORD,pArray:DWORD
		local ptrError,offError,CaptureCnt,ovecsize
		local hReg
		invoke pcre_compile,lpRegEx,0,addr ptrError,addr offError,0
		.if eax == 0
			invoke MessageBox,0,CTXT("compile error"),0,0
			mov eax,FALSE
			ret
		.endif
		mov hReg,eax
		invoke pcre_fullinfo,hReg,0,PCRE_INFO_CAPTURECOUNT,addr CaptureCnt
		add CaptureCnt,1
		mov eax,CaptureCnt
		imul eax,3
		mov ovecsize,eax
		shl eax,2 
		invoke pcre_exec,hReg,0,lpSource,srcLen,0,0,pArray,ovecsize
		.if SDWORD ptr eax <= 0
			invoke MessageBox,0,CTXT("no match"),0,0
			mov eax,FALSE
			ret
		.else
			mov eax,CaptureCnt
			ret
		.endif
ret
RegMatch endp

start:
		invoke GetModuleHandle,NULL
		mov hInstance,eax
		call main
		invoke ExitProcess,NULL
main proc
		local hFile:DWORD,hMapping:DWORD
		local htmlBuffer:DWORD,resultArray[10]:DWORD
		local tmpBuffer[1000]:BYTE
		invoke CreateFile,CTXT("./html.txt"),GENERIC_ALL,FILE_SHARE_DELETE,0,OPEN_EXISTING,0,0
		mov hFile,eax
		invoke CreateFileMapping,hFile,0,PAGE_READWRITE,0,0,0
		mov hMapping,eax
		invoke MapViewOfFile,hMapping,FILE_MAP_ALL_ACCESS,0,0,0
		mov htmlBuffer,eax
		invoke lstrlen,htmlBuffer
		mov ebx,eax
		invoke RegMatch,htmlBuffer,ebx,offset reg,addr resultArray
		invoke CopyString,addr tmpBuffer,htmlBuffer,resultArray[0],resultArray[4]
		invoke MessageBox,0,addr tmpBuffer,CTXT("A match was found from html.txt"),MB_ICONINFORMATION
		invoke CopyString,addr tmpBuffer,htmlBuffer,resultArray[8],resultArray[12]
		invoke MessageBox,0,addr tmpBuffer,CTXT("The first match is"),MB_ICONINFORMATION
		invoke UnmapViewOfFile,htmlBuffer
		invoke CloseHandle,hMapping
		invoke CloseHandle,hFile
ret
main    endp
end start